#ifndef _DRAW
#define _DRAW

typedef enum {LIGHT_BUFFER, DARK_BUFFER} Buffer;
typedef enum {OR, AND, AND_NOT} DrawMode;

typedef struct {
	int x, y;
} Camera;

void draw_bmp(unsigned char* bmp, int x, int y, int width, int height, Buffer buffer, DrawMode drawmode);
int draw_read_pix(int x, int y, char* light_buffer, char* dark_buffer);
void draw_write_pix(int x, int y, int color, char* light_buffer, char* dark_buffer);

static void draw_bmp_or_cl(unsigned char *bmp, int x, int y, int width, int height, char* buffer);
static void draw_bmp_and_cl(unsigned char *bmp, int x, int y, int width, int height, char* buffer);
static void draw_bmp_andnot_cl(unsigned char *bmp, int x, int y, int width, int height, char* buffer);

#endif

