#include "gray.h"
#include <stdlib.h>

#define INT_OFFSET 0x600

#define set_vbr(base)		_builtin_set_vbr(base)


struct st_tmu {
			  union {
					unsigned char BYTE;
					struct {
						   unsigned char	 :5;
						   unsigned char STR2:1;
						   unsigned char STR1:1;
						   unsigned char STR0:1;
						   }	  BIT;
					}		   TSTR;
};
struct st_tmu0 {
			   unsigned int	 TCOR;
			   unsigned int	 TCNT;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short	 :7;
							unsigned short UNF :1;
							unsigned short	 :2;
							unsigned short UNIE:1;
							unsigned short CKEG:2;
							unsigned short TPSC:3;
							}	   BIT;
					 }		  TCR;
};
struct st_intc {
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short NMIL:1;
							unsigned short	 :6;
							unsigned short NMIE:1;
							}	   BIT;
					 }		  ICR0;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _TMU0:4;
							unsigned short _TMU1:4;
							unsigned short _TMU2:4;
							unsigned short _RTC :4;
							}	   BIT;
					 }		  IPRA;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _WDT:4;
							unsigned short _REF:4;
							}	   BIT;
					 }		  IPRB;
			   char			 wk[234];
			   unsigned int	 TRA;
			   unsigned int	 EXPEVT;
			   unsigned int	 INTEVT;
};
struct st_intx {
			   unsigned int	 INTEVT2;
			   union {
					 unsigned char BYTE;
					 struct {
							unsigned char PINT0R:1;
							unsigned char PINT1R:1;
							unsigned char IRQ5R :1;
							unsigned char IRQ4R :1;
							unsigned char IRQ3R :1;
							unsigned char IRQ2R :1;
							unsigned char IRQ1R :1;
							unsigned char IRQ0R :1;
							}	  BIT;
					 }		  IRR0;
			   char			 wk1;
			   union {
					 unsigned char BYTE;
					 struct {
							unsigned char TXI0R:1;
							unsigned char	  :1;
							unsigned char RXI0R:1;
							unsigned char ERI0R:1;
							unsigned char DEI3R:1;
							unsigned char DEI2R:1;
							unsigned char DEI1R:1;
							unsigned char DEI0R:1;
							}	  BIT;
					 }		  IRR1;
			   char			 wk2;
			   union {
					 unsigned char BYTE;
					 struct {
							unsigned char	  :3;
							unsigned char ADIR :1;
							unsigned char TXI2R:1;
							unsigned char	  :1;
							unsigned char RXI2R:1;
							unsigned char ERI2R:1;
							}	  BIT;
					 }		  IRR2;
			   char			 wk3[7];
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short MAI   :1;
							unsigned short IRQLVL:1;
							unsigned short BLMSK :1;
							unsigned short	   :1;
							unsigned short IRQ5S :2;
							unsigned short IRQ4S :2;
							unsigned short IRQ3S :2;
							unsigned short IRQ2S :2;
							unsigned short IRQ1S :2;
							unsigned short IRQ0S :2;
							}	   BIT;
					 }		  ICR1;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short PINT15S:1;
							unsigned short PINT14S:1;
							unsigned short PINT13S:1;
							unsigned short PINT12S:1;
							unsigned short PINT11S:1;
							unsigned short PINT10S:1;
							unsigned short PINT9S :1;
							unsigned short PINT8S :1;
							unsigned short PINT7S :1;
							unsigned short PINT6S :1;
							unsigned short PINT5S :1;
							unsigned short PINT4S :1;
							unsigned short PINT3S :1;
							unsigned short PINT2S :1;
							unsigned short PINT1S :1;
							unsigned short PINT0S :1;
							}	   BIT;
					 }		  ICR2;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short PINT15E:1;
							unsigned short PINT14E:1;
							unsigned short PINT13E:1;
							unsigned short PINT12E:1;
							unsigned short PINT11E:1;
							unsigned short PINT10E:1;
							unsigned short PINT9E :1;
							unsigned short PINT8E :1;
							unsigned short PINT7E :1;
							unsigned short PINT6E :1;
							unsigned short PINT5E :1;
							unsigned short PINT4E :1;
							unsigned short PINT3E :1;
							unsigned short PINT2E :1;
							unsigned short PINT1E :1;
							unsigned short PINT0E :1;
							}	   BIT;
					 }		  PINTER;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _IRQ3:4;
							unsigned short _IRQ2:4;
							unsigned short _IRQ1:4;
							unsigned short _IRQ0:4;
							}	   BIT;
					 }		  IPRC;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _PINT0_7 :4;
							unsigned short _PINT8_15:4;
							unsigned short _IRQ5	:4;
							unsigned short _IRQ4	:4;
							}	   BIT;
					 }		  IPRD;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _DMAC :4;
							unsigned short _SCIF0:4;
							unsigned short _SCIF2:4;
							unsigned short _ADC  :4;
							}	   BIT;
					 }		  IPRE;
			   char			 wk4[524260];
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short	 :8;
							unsigned short _USB:4;
							}	   BIT;
					 }		  IPRF;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _TPU0:4;
							unsigned short _TPU1:4;
							}	   BIT;
					 }		  IPRG;
			   union {
					 unsigned short WORD;
					 struct {
							unsigned short _TPU2:4;
							unsigned short _TPU3:4;
							}	   BIT;
					 }		  IPRH;
};

#define INTC   (*(volatile struct st_intc  *)0xFFFFFEE0)
#define INTX   (*(volatile struct st_intx  *)0xA4000000)
#define TMU	(*(volatile struct st_tmu   *)0xFFFFFE92)
#define TMU0   (*(volatile struct st_tmu0  *)0xFFFFFE94)


Screen* screen = NULL;

#pragma interrupt(gray_interrupt)

void gray_interrupt()
{
	if(screen->which == 1)
	{
		draw_all(screen->DD1);
		screen->which = 2;
		TMU.TSTR.BIT.STR0 = 0;
		TMU0.TCNT = TMU0.TCOR = screen->time1;
	} else {
		draw_all(screen->DD2);
		screen->which = 1;
		TMU.TSTR.BIT.STR0 = 0;
		TMU0.TCNT = TMU0.TCOR = screen->time2;
	}
	TMU0.TCR.BIT.UNF = 0;
	TMU.TSTR.BIT.STR0 = 1;
}

int gray_init()
{
	screen = malloc(sizeof(Screen));
	if(!screen) return 0;
	screen->VRAM1 = malloc(1024);
	screen->VRAM2 = malloc(1024);
	screen->DD1 = malloc(1024);
	screen->DD2 = malloc(1024);
	if(!screen->VRAM1 || !screen->VRAM2 || !screen->DD1 || !screen->DD2) return 0;
	screen->time1 = 3269;
	screen->time2 = 6987;
	screen->which = 1;
	set_vbr((void *)((unsigned int)gray_interrupt - INT_OFFSET));
	TMU0.TCR.WORD = 0x0022;
	TMU0.TCNT = TMU0.TCOR = screen->time1;
	INTC.IPRA.WORD = 0xf000;
	INTC.IPRB.WORD = 0x0000;
	INTX.IPRC.WORD = 0x0000;
	INTX.IPRD.WORD = 0x0000;
	INTX.IPRE.WORD = 0x0000;
	INTX.IPRF.WORD = 0x0000;
	INTX.IPRG.WORD = 0x0000;
	INTX.IPRH.WORD = 0x0000;
	TMU.TSTR.BIT.STR0 = 1;
	return 1;
}

void gray_quit()
{
	TMU0.TCR.WORD = 0x0000;
	TMU0.TCNT = TMU0.TCOR = 0xFFFFFFFF;
	INTC.IPRA.WORD = 0x0000;
	TMU.TSTR.BIT.STR0 = 0;
	TMU.TSTR.BIT.STR1 = 0;
	TMU.TSTR.BIT.STR2 = 0;
	free(screen->VRAM1);
	free(screen->VRAM2);
	free(screen->DD1);
	free(screen->DD2);
	free(screen);
}

void gray_swapBuffers()
{
	char* temp;
	temp = screen->VRAM1;
	screen->VRAM1 = screen->DD1;
	screen->DD1 = temp;
	temp = screen->VRAM2;
	screen->VRAM2 = screen->DD2;
	screen->DD2 = temp;
}

void gray_clearVRAM()
{
	memset(screen->VRAM1, 0, 1024);
	memset(screen->VRAM2, 0, 1024);
}

Screen* gray_getScreen()
{
	return screen;
}

